= nn_reallocmsg(3compat)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nn_reallocmsg - reallocate message (compatible API)

== SYNOPSIS

[source,c]
----
#include <nanomsg/nn.h>

void *nn_reallocmsg(void *old, size_t size);
----

== DESCRIPTION

The `nn_reallocmsg()` reallocates the message _old_, making it of size _size_.

NOTE: This function is provided for API
xref:nng_compat.3compat.adoc[compatibility] with legacy _libnanomsg_.
Consider using the relevant xref:libnng.3.adoc[modern API] instead.

On success, the contents of _old_ are copied into the new message
(truncating if appropriate), then _old_ is deallocated, and a pointer
to the new message payload is returned.

On failure, the _old_ message is unchanged, and the value `NULL` is returned
to the caller.

== RETURN VALUES

This function returns a pointer to message buffer space, or `NULL`
on failure.

== ERRORS

[horizontal]
`ENOMEM`:: Insufficient memory is available.
`EINVAL`:: An invalid _size_ was specified.
`ETERM`:: The library is shutting down.

== SEE ALSO

[.text-left]
xref:nn_allocmsg.3compat.adoc[nn_allocmsg(3compat)],
xref:nn_freemsg.3compat.adoc[nn_freemsg(3compat)],
xref:nn_errno.3compat.adoc[nn_errno(3compat)],
xref:nng_compat.3compat.adoc[nng_compat(3compat)],
xref:nng.7.adoc[nng(7)]
